
/////////////////////////////////////////////////////////////
//
// Source file for ChatRowcolUI
//
//    This class implements the user interface created in 
//    the interface builder. Normally it is not used directly.
//    Instead the subclass, ChatRowcol is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the ChatRowcol files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "ChatRowcolUI.h" // Generated header file for this class

#include <Xm/PushB.h> 
#include <Xm/RowColumn.h> 
#include <Xm/ScrolledW.h> 
#include <Xm/Text.h> 
#include <Xm/TextF.h> 
#include <Vk/VkResource.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  ChatRowcolUI::_defaultChatRowcolUIResources[] = {
        "*chatSendButton.labelString:  Send",
        (char*)NULL
};

ChatRowcolUI::ChatRowcolUI(const char *name) : VkComponent(name) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: ChatRowcol constructor 2


    //---- End editable code block: ChatRowcol constructor 2


} // End Constructor




ChatRowcolUI::ChatRowcolUI(const char *name, Widget parent) : VkComponent(name) 
{ 
    // Call creation function to build the widget tree.

     create(parent);

    //---- Start editable code block: ChatRowcol constructor


    //---- End editable code block: ChatRowcol constructor


} // End Constructor


ChatRowcolUI::~ChatRowcolUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: ChatRowcolUI destructor


    //---- End editable code block: ChatRowcolUI destructor
} // End destructor



void ChatRowcolUI::create ( Widget parent )
{
    Arg      args[5];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources(parent, _defaultChatRowcolUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _chatRowcol = XtVaCreateWidget ( _name,
                                                   xmRowColumnWidgetClass,
                                                   parent, 
                                                   (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _scrolledWindow = XtVaCreateManagedWidget  ( "scrolledWindow",
                                                  xmScrolledWindowWidgetClass,
                                                  _baseWidget, 
                                                  XmNwidth, 494, 
                                                  XmNheight, 232, 
                                                  (XtPointer) NULL ); 


    _chatText = XtVaCreateManagedWidget  ( "chatText",
                                            xmTextWidgetClass,
                                            _scrolledWindow, 
                                            XmNeditMode, XmMULTI_LINE_EDIT, 
                                            XmNeditable, False, 
                                            XmNrows, 14, 
                                            XmNscrollHorizontal, False, 
                                            XmNwidth, 469, 
                                            (XtPointer) NULL ); 
    XtVaSetValues ( _chatText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _chatText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _sendRowcol = XtVaCreateManagedWidget  ( "sendRowcol",
                                              xmRowColumnWidgetClass,
                                              _baseWidget, 
                                              XmNorientation, XmHORIZONTAL, 
                                              XmNwidth, 494, 
                                              XmNheight, 39, 
                                              (XtPointer) NULL ); 


    _sendText = XtVaCreateManagedWidget  ( "sendText",
                                            xmTextFieldWidgetClass,
                                            _sendRowcol, 
                                            XmNcolumns, 51, 
                                            XmNheight, 33, 
                                            (XtPointer) NULL ); 

    XtAddCallback ( _sendText,
                    XmNactivateCallback,
                    &ChatRowcolUI::sendCallback,
                    (XtPointer) this ); 


    _chatSendButton = XtVaCreateManagedWidget  ( "chatSendButton",
                                                  xmPushButtonWidgetClass,
                                                  _sendRowcol, 
                                                  XmNlabelType, XmSTRING, 
                                                  XmNwidth, 55, 
                                                  XmNheight, 33, 
                                                  (XtPointer) NULL ); 

    XtAddCallback ( _chatSendButton,
                    XmNactivateCallback,
                    &ChatRowcolUI::sendCallback,
                    (XtPointer) this ); 


    //---- Start editable code block: ChatRowcolUI create


    //---- End editable code block: ChatRowcolUI create
}

const char * ChatRowcolUI::className()
{
    return ("ChatRowcolUI");
} // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void ChatRowcolUI::sendCallback ( Widget    w,
                                  XtPointer clientData,
                                  XtPointer callData ) 
{ 
    ChatRowcolUI* obj = ( ChatRowcolUI * ) clientData;
    obj->send ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void ChatRowcolUI::send ( Widget, XtPointer ) 
{
    // This virtual function is called from sendCallback.
    // This function is normally overriden by a derived class.
  
}



